#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <../bl_vars.h>
#include <../bl_scripts.h>

void readword(int fp)
  {
    unsigned char c,c1;  
      unsigned i;

      i=0;
      memset(rwstring,NULL,64);

      _dos_read(fp,&c,1,1);
      textpos++;

     rw0:
      if (textpos>=textsize)
       {
           strcpy(rwstring,"fend");
           return;
       }
      if (c==0xD)
        {
            _dos_read(fp,&c,1,1);
            textpos++;
        }
      if (c==0xA)
        {
            _dos_read(fp,&c,1,1);
            textpos++;
        }

      if (c==' ')
        {
           while (c==' ')
            {
                _dos_read(fp,&c,1,1);
                textpos++;
            }
           goto rw0;
        }

      if (c=='"')
        {
            _dos_read(fp,&c,1,1);
            textpos++;
            c1='"';
        }
      else c1=' ';

      while ((c!=c1) && (textpos<textsize))
        {
            
            if (c==0xD)
              {
                  _dos_read(fp,&c,1,1);
                  textpos++;
                  rwstring[i]=NULL;
                  return;
              }
            
            rwstring[i]=c;
            i++;
            _dos_read(fp,&c,1,1);
            textpos++;
        }
  }

unsigned long findfile (int f,unsigned char *name,unsigned long *size)
  {
      unsigned long N,i; //total files in resfile

      unsigned char fname[17], //res element
                    tip;
      unsigned int fsize,offset;

      lseek(f,0,SEEK_SET); //go to beginning of resfile
      _dos_read(f,&N,4,1);  //total files in resfile

      
      for (i=1;i<=N;i++)
        {
            _dos_read(f,&fname,17,1);//reading res element information
            _dos_read(f,&tip,1,1);
            _dos_read(f,&fsize,4,1);
            _dos_read(f,&offset,4,1);
            if (strcmp(name,fname)==0) //file found
              {
                  *size=fsize;
                  return(offset);
              }
        }
      return(0); //file not found
  }


void freadword(int fp) //read word from textfile
  {
      
      unsigned char c,c1;  
      unsigned i;

      i=0;
      memset(rwstring,NULL,64);

      _dos_read(fp,&c,1,1);

     rw0:
      if (eof(fp))
       {
           strcpy(rwstring,"fend");
           return;
       }
      if (c==0xD) _dos_read(fp,&c,1,1);
      if (c==0xA) _dos_read(fp,&c,1,1);

      if (c==' ')
        {
           while (c==' ') _dos_read(fp,&c,1,1);
           goto rw0;
        }

      if (c=='"')
        {
            _dos_read(fp,&c,1,1);
            c1='"';
        }
      else c1=' ';

      while ((c!=c1) && !eof(fp))
        {
            if (c==0xD)
              {
                  _dos_read(fp,&c,1,1);
                  rwstring[i]=NULL;
                  return;
              }
            rwstring[i]=c;
            i++;
            _dos_read(fp,&c,1,1);
        }
  }


void bl_loadini (void)
  {
      printf("Loading ini... \n");
      lseek(inifile,0,SEEK_SET);

      do freadword(inifile); while (strcmp(rwstring,"[Settings]"));

      do
        {
            freadword(inifile);

            if (!strcmp(rwstring,"debug")) isdebug=1;

            if (isdebug) printf("%s ",rwstring);

            if (!strcmp(rwstring,"resfile"))
              {
                  freadword(inifile);
                  if (isdebug) printf("%s \n",rwstring);
                  strcpy(resfilename,rwstring);
                  continue;
              }
            if (!strcmp(rwstring,"mainmenu"))
              {
                  freadword(inifile);
                  if (isdebug) printf("%s \n",rwstring);
                  strcpy(curmenu,rwstring);
                  strcpy(rootmenu,"null");
                  continue;
              } 
            if (!strcmp(rwstring,"menufadeup"))
              {
                  freadword(inifile);
                  ms_up=atoi(rwstring);
                  if (isdebug) printf("%d \n",ms_down);
                  continue;
              }
            if (!strcmp(rwstring,"menufadedown"))
              {
                  freadword(inifile);
                  ms_down=atoi(rwstring);
                  if (isdebug) printf("%d \n",ms_down);
                  continue;
              }
              

        } while (strcmp(rwstring,"fend") && (rwstring[0]!='['));
  }


